pub fn mutual_inclusion(first_pair: &[u32], second_pair: &[u32]) -> bool {
    (first_pair[0] <= second_pair[0] && first_pair[1] >= second_pair[1])
        || (second_pair[0] <= first_pair[0] && second_pair[1] >= first_pair[1])
}

pub fn complete_overlap(first_pair: &[u32], second_pair: &[u32]) -> bool {
    first_pair[0] >= second_pair[0] && first_pair[0] <= second_pair[1]
        || first_pair[1] >= second_pair[0] && first_pair[1] <= second_pair[1]
        || mutual_inclusion(first_pair, second_pair)
}

pub fn solve(file_path: &str, unary_operator: &dyn Fn(&[u32], &[u32]) -> bool) -> i32 {
    std::fs::read_to_string(file_path)
        .expect("Please provide a text file as an argument.")
        .lines()
        .map(|line| {
            let tmp = line.split(',').collect::<Vec<&str>>();
            let first_pair = tmp
                .first()
                .expect("First character error")
                .split('-')
                .map(|first_split| {
                    first_split
                        .parse::<u32>()
                        .expect("Parsing number in first pair failed")
                })
                .collect::<Vec<u32>>();
            let second_pair = tmp
                .last()
                .expect("First character error")
                .split('-')
                .map(|first_split| {
                    first_split
                        .parse::<u32>()
                        .expect("Parsing number in first pair failed")
                })
                .collect::<Vec<u32>>();
            if unary_operator(&first_pair, &second_pair) {
                1
            } else {
                0
            }
        })
        .collect::<Vec<i32>>()
        .iter()
        .sum()
}